/*
 * Copyright (c) 2004, 2005, 2006, 2007, 2008
 *	Luiz Otavio O Souza <loos.br@gmail.com>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * $Id: io.h,v 1.2 2008/01/03 12:27:32 loos-br Exp $
 */

#ifndef IO_H
#define IO_H

#include <stdarg.h>

#define STDIN		0
#define STDOUT		1
#define STDERR		2

int io_read(register int fd, register char *buf, register int len);
int io_write(register int fd, register const char *buf, register int len);
int timeoutread(int t, int fd, char *buf, int len);
int timeoutwrite(int t, int fd, char *buf, int len);
int io_printf(int fd, const char *fmt, ...);
int io_vprintf(int fd, const char *fmt, va_list ap);

#endif
